// pages/category/category.js
const app = getApp()
const wxService = require('../../utils/wxService')
import { Integer } from '../../utils/integerDigitalConvertion'
const { memberId, member } = wx.getStorageSync('_baseUserInfo')
const defaultCategoryImg = 'https://img3.bigaka.com/prd/3001/202004/20200428/30012dfcf171-5140-40fc-babd-4482da4f7a1a.jpg';
const defaultWidthCategoryImg = 'https://img3.bigaka.com/prd/3001/202004/20200428/300168439317-6b28-4947-9054-b6d08b9081ce.jpg';
wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    currentFirstCategory : {},
    navData: [],
    secondCategory : [],
    defaultCategoryImg : defaultCategoryImg,
    defaultWidthCategoryImg : defaultWidthCategoryImg,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let share_memberId = options.memberId;
    if (share_memberId) {
      let tentacleInfo = {
        content: '分类',
        title: '分类',
        tentacleId: share_memberId,
        contentType: app.globalData.contants.SHARE_TYPE.CLASSIFY,
        type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
      };

      this.generatePointObject(tentacleInfo);
    }
    
    if (typeof this.getTabBar === 'function' &&
      this.getTabBar()) {
      this.getTabBar().setData({
        selected: 1
      })
    }

    this.getCategoryList();
  },

  //跳转到商品列表
  onTapToGoodsList(e){
    let id = e.currentTarget.dataset.id;
    let name = e.currentTarget.dataset.label;
    wx.navigateTo({
      url: `/subPackage/page/pages/categoryPro/categoryPro?id=${id}&name=${name}`,
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    
  },

  // 分类列表
  getCategoryList() {
    wx.showLoading({
      title: '加载中'
    })
    // wxService.get(`/sale/product/mallCategory/buyer/findCategoryTree`).then(res => {
    wxService.get(`/sale/product/mallCategory/findCategoryTree?state=c`).then(res => {
      let { result, data } = res.data
      if (result == 0) {
        wx.hideLoading();
        data = data ? data : [];
        data.forEach(item => {
          item.active = false;
        });
        // 处理三级标识
        this.handleFirstCategoryHasThirdChildren(data);
        if(data.length > 0){
          data[0].active = true;
          this.data.currentFirstCategory = data[0];
          this.data.secondCategory = data[0].children ? data[0].children : [];
          this.data.secondCategory = this.handleSecondCategoryChildren(this.data.secondCategory);
        }
        
        this.setData({
          navData: data,
          secondCategory : this.data.secondCategory,
          currentFirstCategory : this.data.currentFirstCategory,
        });
      }
    }).finally(() => {
      wx.hideLoading()
    })
  },

  selectMenu: function (e) {
    let index = e.currentTarget.dataset.index;
    this.data.navData.forEach(item => {
      item.active = false;
    });
    this.data.navData[index].active = true;
    this.data.currentFirstCategory = this.data.navData[index];
    this.data.secondCategory = this.data.navData[index].children ? this.data.navData[index].children : [];
    this.data.secondCategory = this.handleSecondCategoryChildren(this.data.secondCategory);
    this.setData({
      navData: this.data.navData,
      secondCategory : this.data.secondCategory,
      currentFirstCategory : this.data.currentFirstCategory,
    });
  },

  //处理二级分类下的三级 如果没有三级则children 设置为空数组
  handleSecondCategoryChildren(secondCategory){
    secondCategory.forEach(item => {
      item.children = item.children ? item.children : [];
    });

    return secondCategory;
  },

  //处理某一级是不是都有三级分类
  handleFirstCategoryHasThirdChildren(navData){
    navData.forEach(first => {
      first.hasThirdChildren = false;
      let firstChildren = first.children ? first.children : [];
      if(firstChildren.length > 0){
          for(let i = 0 ;i < firstChildren.length ; i ++){
            firstChildren[i].children = firstChildren[i].children ? firstChildren[i].children : [];
            if(firstChildren[i].children.length > 0){
              first.hasThirdChildren = true;
              break;
            }
          }
      }
    });
  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {
   
    //修改为参数memberId
    const { memberId, member } = wx.getStorageSync('_baseUserInfo')
    var path = `pages/category/category`;
    if (memberId) {
      let m = Integer.digit(memberId, 10, 64);
      path = `pages/category/category?m=${m}`;
    }
    return {
      title: '分类',
      path: path
    }
  }
})